// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_contracts.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listDelegatedServiceConnectionGrantsForContract = `-- name: ListDelegatedServiceConnectionGrantsForContract :many
SELECT
    gdsc.outway_peer_id as outway_peer_id,
    gdsc.service_type as service_type,
    gdsc.service_peer_id as service_peer_id,
    gdsc.service_name as service_name,
    gdsc.service_publication_delegator_peer_id as service_publication_delegator_peer_id,
    gdsc.delegator_peer_id as delegator_peer_id,
    gdsc.public_key_thumbprint as public_key_thumbprint
FROM
    contracts.grants_delegated_service_connection as gdsc
WHERE
        gdsc.content_hash = $1
GROUP BY
    gdsc.hash
`

type ListDelegatedServiceConnectionGrantsForContractRow struct {
	OutwayPeerID                      string
	ServiceType                       ContractsServiceType
	ServicePeerID                     string
	ServiceName                       string
	ServicePublicationDelegatorPeerID pgtype.Text
	DelegatorPeerID                   string
	PublicKeyThumbprint               string
}

func (q *Queries) ListDelegatedServiceConnectionGrantsForContract(ctx context.Context, contentHash string) ([]*ListDelegatedServiceConnectionGrantsForContractRow, error) {
	rows, err := q.db.Query(ctx, listDelegatedServiceConnectionGrantsForContract, contentHash)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListDelegatedServiceConnectionGrantsForContractRow{}
	for rows.Next() {
		var i ListDelegatedServiceConnectionGrantsForContractRow
		if err := rows.Scan(
			&i.OutwayPeerID,
			&i.ServiceType,
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ServicePublicationDelegatorPeerID,
			&i.DelegatorPeerID,
			&i.PublicKeyThumbprint,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listDelegatedServicePublicationGrantsForContract = `-- name: ListDelegatedServicePublicationGrantsForContract :many
SELECT
    gdsp.directory_peer_id as directory_peer_id,
    gdsp.service_peer_id as service_peer_id,
    gdsp.service_name as service_name,
    gdsp.service_protocol as service_protocol,
    gdsp.delegator_peer_id as delegator_peer_id
FROM
    contracts.grants_delegated_service_publication as gdsp
WHERE
    gdsp.content_hash = $1
GROUP BY
    gdsp.hash
`

type ListDelegatedServicePublicationGrantsForContractRow struct {
	DirectoryPeerID string
	ServicePeerID   string
	ServiceName     string
	ServiceProtocol ContractsServiceProtocolType
	DelegatorPeerID string
}

func (q *Queries) ListDelegatedServicePublicationGrantsForContract(ctx context.Context, contentHash string) ([]*ListDelegatedServicePublicationGrantsForContractRow, error) {
	rows, err := q.db.Query(ctx, listDelegatedServicePublicationGrantsForContract, contentHash)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListDelegatedServicePublicationGrantsForContractRow{}
	for rows.Next() {
		var i ListDelegatedServicePublicationGrantsForContractRow
		if err := rows.Scan(
			&i.DirectoryPeerID,
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ServiceProtocol,
			&i.DelegatorPeerID,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listServiceConnectionGrantsForContract = `-- name: ListServiceConnectionGrantsForContract :many
SELECT
    gc.outway_peer_id as outway_peer_id,
    gc.service_type as service_type,
    gc.service_peer_id as service_peer_id,
    gc.service_name as service_name,
    gc.service_publication_delegator_peer_id as service_publication_delegator_peer_id,
    gc.public_key_thumbprint as public_key_thumbprint
FROM
    contracts.grants_service_connection as gc
WHERE
        gc.content_hash = $1
GROUP BY
    gc.hash
`

type ListServiceConnectionGrantsForContractRow struct {
	OutwayPeerID                      string
	ServiceType                       ContractsServiceType
	ServicePeerID                     string
	ServiceName                       string
	ServicePublicationDelegatorPeerID pgtype.Text
	PublicKeyThumbprint               string
}

func (q *Queries) ListServiceConnectionGrantsForContract(ctx context.Context, contentHash string) ([]*ListServiceConnectionGrantsForContractRow, error) {
	rows, err := q.db.Query(ctx, listServiceConnectionGrantsForContract, contentHash)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListServiceConnectionGrantsForContractRow{}
	for rows.Next() {
		var i ListServiceConnectionGrantsForContractRow
		if err := rows.Scan(
			&i.OutwayPeerID,
			&i.ServiceType,
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ServicePublicationDelegatorPeerID,
			&i.PublicKeyThumbprint,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listServicePublicationGrantsForContract = `-- name: ListServicePublicationGrantsForContract :many
SELECT
    gp.hash as hash,
    gp.directory_peer_id as directory_peer_id,
    gp.service_peer_id as service_peer_id,
    gp.service_name as service_name,
    gp.service_protocol as service_protocol
FROM
    contracts.grants_service_publication as gp
WHERE
    gp.content_hash = $1
`

type ListServicePublicationGrantsForContractRow struct {
	Hash            string
	DirectoryPeerID string
	ServicePeerID   string
	ServiceName     string
	ServiceProtocol ContractsServiceProtocolType
}

func (q *Queries) ListServicePublicationGrantsForContract(ctx context.Context, contentHash string) ([]*ListServicePublicationGrantsForContractRow, error) {
	rows, err := q.db.Query(ctx, listServicePublicationGrantsForContract, contentHash)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListServicePublicationGrantsForContractRow{}
	for rows.Next() {
		var i ListServicePublicationGrantsForContractRow
		if err := rows.Scan(
			&i.Hash,
			&i.DirectoryPeerID,
			&i.ServicePeerID,
			&i.ServiceName,
			&i.ServiceProtocol,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listSignaturesForContract = `-- name: ListSignaturesForContract :many

SELECT
    signature_type as type,
    peer_id,
    p.name as peer_name,
    certificate_thumbprint,
    signature as jws,
    cs.signed_at
FROM
    contracts.contract_signatures as cs
LEFT JOIN
    peers.peers as p
ON
    p.id = cs.peer_id
WHERE
    cs.content_hash = $1
`

type ListSignaturesForContractRow struct {
	Type                  ContractsSignatureType
	PeerID                string
	PeerName              pgtype.Text
	CertificateThumbprint string
	Jws                   string
	SignedAt              pgtype.Timestamptz
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) ListSignaturesForContract(ctx context.Context, contentHash string) ([]*ListSignaturesForContractRow, error) {
	rows, err := q.db.Query(ctx, listSignaturesForContract, contentHash)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListSignaturesForContractRow{}
	for rows.Next() {
		var i ListSignaturesForContractRow
		if err := rows.Scan(
			&i.Type,
			&i.PeerID,
			&i.PeerName,
			&i.CertificateThumbprint,
			&i.Jws,
			&i.SignedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
